#include <stm32f0xx.h>
#include "abstract-gpio-init.hpp"

#ifndef ABSTRACT_GPIO_H
#define ABSTRACT_GPIO_H

namespace stm32f072xb {

class AbstractGpio {
   private:
	GPIO_TypeDef* _gpio;
	const AbstractGpioInit _gpioInit;

   protected:
	void setupRegister() const;

   public:
	AbstractGpio(GPIO_TypeDef* gpio, const AbstractGpioInit& gpioInit);
	~AbstractGpio();
	GPIO_TypeDef* getGpio() const;
	uint8_t getPin() const;
	uint8_t getPullMode() const;
};

}  // namespace stm32f072xb

#endif
